User account creation filtered due to spam.

Bug 16408 - [3.4 Regression] internal compiler error: in delete_insn, at cfgrtl.c:146
Summary: [3.4 Regression] internal compiler error: in delete_insn, at cfgrtl.c:146
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: rtl-optimization (show other bugs)
Version: 3.4.1
: P2 critical
Target Milestone: 3.4.2
Assignee: Not yet assigned to anyone
URL:
Keywords: ice-on-valid-code, monitored, patch
Depends on:
Blocks:
 
Reported: 2004-07-07 14:57 UTC by Treeve Jelbert
Modified: 2004-09-09 23:40 UTC (History)
3 users (show)

See Also:
Host:
Target:
Build:
Known to work: 4.0 3.3.4
Known to fail: 3.4.0
Last reconfirmed: 2004-07-07 17:05:10


Attachments
source file (84.24 KB, application/x-bzip2)
2004-07-07 15:03 UTC, Treeve Jelbert
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Treeve Jelbert 2004-07-07 14:57:17 UTC
gcc-3.4.1 linux-2.6.7 x86 
 
 
g++ -O -march=athlon-tbird -mmmx -m3dnow -pipe -O3 -O -march=athlon-tbird 
-mmmx -m3dnow -pipe -O3 -I../src/include/gen -I../src/include -O  
-march=athlon-tbird -mmmx -m3dnow -pipe -O3  -fno-omit-frame-pointer 
-fno-builtin -DNDEBUG -DLINUX -pipe -MMD -fPIC -fmessage-length=0  
-DPROD_BUILD -DSUPERSERVER -I../src/include/gen -I../src/include -O 
-march=athlon-tbird -mmmx -m3dnow -pipe -O3  -fno-omit-frame-pointer 
-fno-builtin -DNDEBUG -DLINUX -pipe -MMD -fPIC -fmessage-length=0  
-DPROD_BUILD -c ../src/jrd/svc.cpp -o ../temp/superserver/jrd/svc.o 
../src/jrd/svc.cpp: In function `void* SVC_read_ib_log(void*)': 
../src/jrd/svc.cpp:2106: internal compiler error: in delete_insn, at 
cfgrtl.c:146
Comment 1 Treeve Jelbert 2004-07-07 15:03:58 UTC
Created attachment 6706 [details]
source file
Comment 2 Treeve Jelbert 2004-07-07 15:07:06 UTC
gcc -v 
Reading specs from /usr/lib/gcc/i686-pc-linux-gnu/3.4.1/specs 
Configured with: /usr/src/gcc-3.4.1/configure --host=i686-pc-linux-gnu 
--prefix=/usr --infodir=/usr/share/info --mandir=/usr/share/man 
--enable-threads=posix --with-system-zlib 
Thread model: posix 
gcc version 3.4.1 
 
Comment 3 Andrew Pinski 2004-07-07 15:53:07 UTC
I can confirm this but I do not have a reduced testcase, someone please reduce this for me.
Comment 4 Volker Reichelt 2004-07-07 17:05:10 UTC
Here's a testcase that crashes the C as well as the C++ frontend.
Just compile with "-O2 -fPIC":

===============================================
int *baz() __attribute__ ((__const__));

void bar(int**);

void foo(int i)
{
  int *p;

  if (i) *p = 0;
  bar(&p);
  *p++ = *baz();
  *p++ = 0;
}
===============================================
Comment 5 Volker Reichelt 2004-08-25 12:36:09 UTC
The regression was introduced here:
: Search converges between 2003-06-19-trunk (#269) and 2003-06-20-trunk (#270).

It was fixed on mainline by the tree-ssa-merge.
Comment 6 Volker Reichelt 2004-08-25 13:42:17 UTC
Zdenek, the regression appeared with your patch
http://gcc.gnu.org/ml/gcc-cvs/2003-06/msg00947.html

This is consistent with the fact that the bug disappears when
I specify -fno-gcse. Could you please have a look?
Comment 7 Zdenek Dvorak 2004-08-25 18:18:23 UTC
Patch:

http://gcc.gnu.org/ml/gcc-patches/2004-08/msg02039.html
Comment 8 Mark Mitchell 2004-08-29 18:12:07 UTC
Postponed until GCC 3.4.3.
Comment 9 Mark Mitchell 2004-08-29 18:14:46 UTC
Postponed until GCC 3.4.3.
Comment 10 CVS Commits 2004-09-01 20:28:59 UTC
Subject: Bug 16408

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	rakdver@gcc.gnu.org	2004-09-01 20:28:41

Modified files:
	gcc            : ChangeLog gcse.c 

Log message:
	PR rtl-optimization/16408
	* gcse.c (replace_store_insn): Fix LIBCALL/RETVAL notes.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&r1=2.5193&r2=2.5194
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/gcse.c.diff?cvsroot=gcc&r1=1.312&r2=1.313

Comment 11 CVS Commits 2004-09-01 20:30:35 UTC
Subject: Bug 16408

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_4-branch
Changes by:	rakdver@gcc.gnu.org	2004-09-01 20:30:29

Modified files:
	gcc            : ChangeLog gcse.c 

Log message:
	PR rtl-optimization/16408
	* gcse.c (replace_store_insn): Fix LIBCALL/RETVAL notes.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=2.2326.2.607&r2=2.2326.2.608
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/gcse.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.288.2.7&r2=1.288.2.8

Comment 12 Zdenek Dvorak 2004-09-01 20:31:41 UTC
Fixed.